function solving(filename1, filename2, step)	%Funktion bentigt Funktion emt.m
disp ("Achtung: Die Rechenzeit geht quadratisch mit der Stepgre");
%renvar = [0.10, 0.20; 0.20, 0.30; 0.08, 0.04];
%korr = [1, 0.5, -0.5; 0.5, 1, 0.3; -0.5, 0.2, 1];
%anteile = [0.4; 0.4; 0.2];

%Einlesen der Matrizen mit Renditen, Varianzen und Korrelationen
renvar = load (filename1);
korr = load (filename2);

%Check auf Dimensionsgleichheit
dim = rows(renvar)
dim2 = rows(korr)
if dim != dim2
	disp  ("Error: Dimensionen falsch");
endif

%---------------------------------------------------
if dim == 2
%Bruteforce aller Anteilmglichkeiten fr dim = 2
%Anzahl Berechnungen:
nr=0;
%Ausgabematrix Startwert (Anteil WP 1, WP2, Rendite, Varianz)
I = [0,0,0,0];
%Start Schleife
for i=0:step:1
	for j = 0:step:1
			if (i+j == 1)
				%---------------------------------
				anteile = [i,j];
				temp = emt(renvar, korr, anteile);
				temp2 =  cat(2,anteile,temp) ;
				I = cat(1, I, temp2);
				nr = nr + 1;
				%---------------------------------
			endif
	endfor
endfor
X = I(:,3);
Y = I(:,4);
endif
%End Schleife
%---------------------------------------------------

%---------------------------------------------------
if dim == 3
%Bruteforce aller Anteilmglichkeiten fr dim = 3
%Anzahl Berechnungen:
nr=0;
%Ausgabematrix Startwert (Anteil WP 1, WP2, WP3, Rendite, Varianz)
I = [0,0,0,0,0];
%Start Schleife
for i=0:step:1
	for j = 0:step:1
		for k = 0:step:1
			if (i+j+k == 1)
				%---------------------------------
				anteile = [i,j,k];
				temp = emt(renvar, korr, anteile);
				temp2 =  cat(2,anteile,temp) ;
				I = cat(1, I, temp2);
				nr = nr + 1;
				%---------------------------------
			endif
		endfor
	endfor
endfor
X = I(:,4);
Y = I(:,5);
endif
%End Schleife
%---------------------------------------------------

%---------------------------------------------------
if dim == 4
%Bruteforce aller Anteilmglichkeiten fr dim = 4
%Anzahl Berechnungen:
nr=0;
I = [0,0,0,0,0,0];
%Start Schleife
for i=0:step:1
	for j = 0:step:1
		for k = 0:step:1
			for l = 0:step:1
				%--------------------------------------
				if (i+j+k+l == 1)
					anteile = [i,j,k,l];
					temp = emt(renvar, korr, anteile);
					temp2 =  cat(2,anteile,temp) ;
					I = cat(1, I, temp2);
					nr = nr + 1;
				endif
				%--------------------------------------
			endfor
		endfor
	endfor
endfor
X = I(:,5);
Y = I(:,6);
endif
%End Schleife
%---------------------------------------------------

%---------------------------------------------------
if dim == 5
%Bruteforce aller Anteilmglichkeiten fr dim = 5
%Anzahl Berechnungen:
nr=0;
I = [0,0,0,0,0,0,0];
%Start Schleife
for i=0:step:1
	for j = 0:step:1
		for k = 0:step:1
			for l = 0:step:1
				for m = 0:step:1
					%--------------------------------------
					if (i+j+k+l+m == 1)
						anteile = [i,j,k,l,m];
						temp = emt(renvar, korr, anteile);
						temp2 =  cat(2,anteile,temp) ;
						I = cat(1, I, temp2);
						nr = nr + 1;
					endif
					%--------------------------------------
				endfor
			endfor
		endfor
	endfor
endfor
X = I(:,6);
Y = I(:,7);
endif
%End Schleife
%---------------------------------------------------

%---------------------------------------------------
if dim == 6
%Bruteforce aller Anteilmglichkeiten fr dim = 6
%Anzahl Berechnungen:
nr=0;
I = [0,0,0,0,0,0,0,0];
%Start Schleife
for i=0:step:1
	for j = 0:step:1
		for k = 0:step:1
			for l = 0:step:1
				for m = 0:step:1
					for n = 0:step:1
						%--------------------------------------
						if (i+j+k+l+m+n == 1)
							anteile = [i,j,k,l,m,n];
							temp = emt(renvar, korr, anteile);
							temp2 =  cat(2,anteile,temp) ;
							I = cat(1, I, temp2);
							nr = nr + 1;
						endif
						%--------------------------------------
					endfor
				endfor
			endfor
		endfor
	endfor
endfor
X = I(:,7);
Y = I(:,8);
endif
%End Schleife
%---------------------------------------------------

%---------------------------------------------------
if dim == 7
%Bruteforce aller Anteilmglichkeiten fr dim = 7
%Anzahl Berechnungen:
nr=0;
I = [0,0,0,0,0,0,0,0,0];
%Start Schleife
for i=0:step:1
	for j = 0:step:1
		for k = 0:step:1
			for l = 0:step:1
				for m = 0:step:1
					for n = 0:step:1
						for o = 0:step:1
							%--------------------------------------
							if (i+j+k+l+m+n+o == 1)
								anteile = [i,j,k,l,m,n,o];
								temp = emt(renvar, korr, anteile);
								temp2 =  cat(2,anteile,temp) ;
								I = cat(1, I, temp2);
								nr = nr + 1;
							endif
							%--------------------------------------
						endfor
					endfor
				endfor
			endfor
		endfor
	endfor
endfor
X = I(:,8);
Y = I(:,9);
endif
%End Schleife
%---------------------------------------------------


disp ("Anzahl der durchgefuehrten Berechnungen:");
disp(nr);
%Plotting aller Punkte (Rendite vs. Varianz):
clf;
plot (Y,X, "r.")
xlabel ("Varianz");
ylabel ("Rendite");

%Save aller Datenstze:
	path = "M:/EigeneDateien/Octave/";
	endung = ".dat";
	savename = "emt_matrix";
	fullpath = [path, savename, endung];
	save ("-ascii", fullpath, "I");
	disp ("Matrix saved in");
	disp (fullpath);
endfunction